# SOLUTION HW 2
import numpy as np
import matplotlib.pyplot as plt
#-----------------------
# DATA GENERATION
NROW = 2
NCOL =2
NPTS = 40


# Exact coeff
w_exact = np.zeros((NROW))
w_exact =[-0.3,0.5]


# Noise signal 
e	=np.zeros((NPTS))
e_std   = 0.2 
e_var   = e_std**2
e_mean  = 0.0
np.random.seed (1234)
e       = np.random.normal(e_mean,e_std,NPTS)

# input basis vectors
x         = np.zeros((NROW,NPTS))
x1        = np.random.uniform(-1.0,1.0,NPTS)

for i in range(0,NPTS,1):
	x[0][i]   = 1.0
	x[1][i]   = x1[i]

# output vector
t       = np.zeros((NPTS))
for i in range(0,NPTS,1):
	t[i] = e[i]
	for k in range (0,NCOL,1):
		t[i]      = t[i] + w_exact[k]*x[k][i]
####################################################
# part (a)
####################################################
t_mean_approx= np.sum(t  )/NPTS
t_var_approx = np.sum(t*t)/NPTS - t_mean_approx**2
print(' HW2 Part (a)')
print('approx mean(exact): ', t_mean_approx,'(',w_exact[0],')')
print('approx var (exact): ', t_var_approx,'(',w_exact[1]**2/3 + e_var,')')

####################################################
# part (b,c)
# MLE solution
####################################################
phi_trans = np.zeros((NROW,NPTS))
for i in range(0,NPTS,1):
	phi_trans[0][i] = x[0][i]
	phi_trans[1][i] = x[1][i]

A = np.matmul(phi_trans,np.transpose(phi_trans))
B = np.matmul(phi_trans,t)
w_approx = np.linalg.solve(A,B)

print(' HW2 Part (b)')
print ('MLE approx (exact)', w_approx,'(',w_exact,')')
print ('condition number A',"%.4f" % np.linalg.cond(A))
####################################################

x1_mean_approx= np.sum(x1  )/NPTS
x1_var_approx = np.sum(x1*x1)/NPTS - x1_mean_approx**2
print('approx mean(var) x1: ', x1_mean_approx,'(',x1_var_approx,')')

e_mean_approx= np.sum(e  )/NPTS
e_var_approx = np.sum(e*e)/NPTS - e_mean_approx**2
print('approx mean(var) e: ', e_mean_approx,'(',e_var_approx,')')

ez= np.sum ( (e-e_mean_approx)*(x1-x1_mean_approx))/NPTS
print('approx mean(var) ez: ', ez,'(',0,')')



exit()
